# Student class representing students
class Student:
    def __init__(self, name: str, student_id: int) -> None:
        self.name = name
        self.student_id = student_id

    def get_student_info(self) -> str:
        return f"Student: {self.name}, ID: {self.student_id}"

# Professor class associated with students
class Professor:
    def __init__(self, name: str) -> None:
        self.name = name
        self.students_taught = []  # List to hold student objects associated with the professor

    def add_student(self, student: Student) -> None:
        self.students_taught.append(student)  # Method to associate a student with a professor

    def get_teaching_info(self) -> str:
        students_info = [student.get_student_info() for student in self.students_taught]
        return f"Professor {self.name} teaches: {', '.join(students_info)}"

# Creating instances
student1 = Student("Alice", 101)
student2 = Student("Bob", 102)

prof = Professor("Dr. Johnson")

# Associating students with the professor
prof.add_student(student1)
prof.add_student(student2)

# Accessing professor's teaching information
print(prof.get_teaching_info())  # Output: Professor Dr. Johnson teaches: Student: Alice, ID: 101, Student: Bob, ID: 102